#include <stdio.h>
#include <stdlib.h>
#define RELEASE "0.11"

unsigned int debughelp=0;
unsigned int parthelp=0;
unsigned int porthelp=0;
typedef struct 
{
	unsigned char xcorr;
	unsigned char ycorr;
	unsigned char escape;
	float sizex;
	float sizey;

} _partheader;

typedef struct
{
	unsigned char name[128];
	float xpos;
	float ypos;
} _interfaces;


typedef struct
{
	unsigned char name[128];
	unsigned char filename[128];
	float xpos;
	float ypos;
	float rotate;
	int portnum;
	_interfaces ports[32];
	_partheader parts;
} _part;
int readtoken(unsigned char *part,unsigned char *line,unsigned char token,int pos)
{
	int i;
	int j=0;
	int l=strlen(line);
	unsigned char c=0;
	for (i=pos;(i<l && c!=token);i++)
	{
		c=line[i];
		if (c!=token && c!=10 && c!=0 && c!=13) {part[j++]=c;part[j]=0;}
	}
	return i;
}
float getfloat(unsigned char* line)
{
	int l=strlen(line);
	unsigned char c=0;
	signed int neg=0;
	unsigned int digits=0;
	float dotat=-1;
	float ex=0.1;
	float x=0;
	int i;
	for (i=0;(i<l && c!=' ' && c!=10);i++)
	{
		c=line[i];
		if (c=='-') neg=1-neg;
		if (c=='.') dotat=ex;
		if (ex==0.1 && c>='1' && c<='9') {digits++;ex=10*ex;} // fuer den fall, dass die zahl als 0.55555 geschrieben ist
		if (ex!=0.1 && c>='0' && c<='9') {digits++;ex=10*ex;} // fuer den fall, dass die zahl als 10.5555 geschrieben ist
	}
	c=0;
	if (dotat==-1) dotat=ex;
	for (i=0;(i<l && c!=' ' && c!=10);i++)
	{
		c=line[i];
		if (c>='0' && c<='9') 
		{
			x+=(c-'0')*dotat;
			dotat=dotat/10;
		}	
	}
	if (neg) x=-x;
	return x;
}
void freadline(unsigned char* line,int size,FILE *f)
{
	fgets(line,size,f);
}
_partheader parseheader(FILE *f)
{
	_partheader p;
	int i;
	unsigned char line[1024];
	int ret=0;
	int parsed=0;
	int definesfound=0;
	while (!feof(f) && !ret)
	{
		freadline(line,sizeof(line),f);
//		fgets(line,sizeof(line),f);
		if (definesfound)
		{
			if (strncmp("xcorr=",line,6)==0) {p.xcorr=line[6];parsed|=1;fprintf(stderr,"parse> xcorr='%c'\n",p.xcorr);}
			if (strncmp("ycorr=",line,6)==0) {p.ycorr=line[6];parsed|=2;fprintf(stderr,"parse> ycorr='%c'\n",p.ycorr);}
			if (strncmp("escape=",line,6)==0) {p.escape=line[7];parsed|=4;fprintf(stderr,"parse> escape='%c'\n",p.escape);}
			if (strncmp("sizex=",line,6)==0) {p.sizex=getfloat(&line[6]);parsed|=8;fprintf(stderr,"parse> sizex=%7.3f\n",p.sizex);}
			if (strncmp("sizey=",line,6)==0) {p.sizey=getfloat(&line[6]);parsed|=16;fprintf(stderr,"parse> sizey=%7.3f\n",p.sizey);}
		}
		if (strncmp(line,"[defines]",9)==0) definesfound=1;
		if (strncmp(line,"[interface]",11)==0) ret=1;
	}
	if (!ret || parsed!=31)
	{		
		fprintf(stderr,"error> in _partheader\n");
		if (parsed!=31 && ret) fprintf(stderr,"error> either xcorr,ycorr,escape,sizex or sizey is missing\n");
		exit(1);
	}
	return p;

}
_interfaces getinterface(unsigned char *line)
{
	_interfaces in;
	int i;
	unsigned char tmp[128];
	int ret=0;
	int ports=0;
	int p=0;
	
	p=readtoken(in.name,line,' ',p);
	p=readtoken(tmp,line,' ',p);
	in.xpos=getfloat(tmp);
	p=readtoken(tmp,line,' ',p);
	in.ypos=getfloat(tmp);

	return in;
	
}

void drawpart(FILE *f,float xoffs,float yoffs,float rotate,_partheader p)
{
	unsigned char line[1024];
	unsigned char c;
	float x,y;
	int escaped=0;
	int l;
	int i,j;
	line[0]=0;
	while (!feof(f))
	{
		freadline(line,sizeof(line),f);	
		if (!feof(f))
		{
			l=strlen(line);
			for (i=0;i<l;i++)
			{
				c=line[i];
				if (c!=10)
				{
					if (escaped) 
					{
						printf("%c",c);
						escaped=0;
					} else {
						if (c==p.escape) escaped=1;			
						if (c==p.xcorr) x=getfloat(&line[i+1]);
						if (c==p.ycorr) y=getfloat(&line[i+1]);
						if (c==p.xcorr || c==p.ycorr) 
						{
							if (c==p.xcorr)
							{
								printf("%7.3f ",x+xoffs); // TODO: rotation hier einbauen
							}
							if (c==p.ycorr)
							{
								printf("%7.3f ",y+yoffs); // TODO: rotation hier einbauen
							}
							while (c!=' ')
							{
								c=line[i++];
							}
							i--;
							
						} else if (c!=p.escape) printf("%c",c);
					}
				}	
			}
			printf("\n");
		}
	}
	fclose(f);
}

void parsecirc(unsigned char *filename)
{
	FILE *f=fopen(filename,"rb");
	unsigned char line[1024];
	int i;
	int j;
	float cursorx=0;
	float cursory=0;
	line[0]=0;
	while (!feof(f) && strncmp(line,"[draw]",6))
	{
		freadline(line,sizeof(line),f);
	}
	while (!feof(f))
	{
		freadline(line,sizeof(line),f);
		if (strncmp(line,"start",5)==0)
		{

		}	
	}
	fclose(f);	
}
_part putpart(unsigned char* filename,unsigned char* partname,unsigned char* portname,float xoffs,float yoffs,float rotate)
{
	_part part;
	FILE *f;
	unsigned char line[1024]="\0";
	int i;

	strncpy(part.filename,filename,128);
	strncpy(part.name,partname,128);
	fprintf(stderr,"draw> name [%s]\n",partname);
	part.xpos=xoffs;
	part.ypos=yoffs;
	part.rotate=rotate;
	


	f=fopen(part.filename,"rb");
	fprintf(stderr,"draw> parseing header of [%s]\n",filename);
	part.parts=parseheader(f);
	fprintf(stderr,"draw> parseing interfaces\n");
	part.portnum=0;
	fprintf(stderr,"interface> tryping to find [%s]\n",portname);
	while (!feof(f) && strncmp(line,"[draw]",6))
	{	
		freadline(line,128,f);
		if (strncmp(line,"[draw]",6))
		{
			part.ports[part.portnum]=getinterface(line);
			fprintf(stderr,"interface> %i [%s] @%7.3f,%7.3f\n",part.portnum,part.ports[part.portnum].name,part.ports[part.portnum].xpos,part.ports[part.portnum].ypos);
			if (porthelp)
			{
				printf("\\put {{\\tiny %s}} at %7.3f %7.3f\n",part.ports[part.portnum].name,part.xpos+part.ports[part.portnum].xpos,part.ypos+part.ports[part.portnum].ypos);
			}
			if (strncmp(portname,part.ports[part.portnum].name,128)==0) 
			{
				xoffs=part.ports[part.portnum].xpos;
				yoffs=part.ports[part.portnum].ypos;
				fprintf(stderr,"interface> shift by %7.3f,%7.3f\n",xoffs,yoffs);
			}
			part.portnum++;
		}
		if (strncmp(portname,"-",1)==0)
		{
			xoffs=part.parts.sizex/2;
			yoffs=part.parts.sizey/2;
		}	

	}

	if (parthelp)
	{
		printf("\\put {{\\tiny %s}} at %7.3f %7.3f\n",part.name,part.xpos+part.parts.sizex/2,part.ypos+part.parts.sizey/2);
	}
	drawpart(f,part.xpos-xoffs,part.ypos-yoffs,part.rotate,part.parts);
	for (i=0;i<part.portnum;i++)
	{
		part.ports[i].xpos+=(part.xpos-xoffs);
		part.ports[i].ypos+=(part.ypos-yoffs);
	}
	fclose(f);

	return part;	

}
void gpl()
{

	printf("		    GNU GENERAL PUBLIC LICENSE\n");
	printf("		       Version 2, June 1991\n");
	printf("\n");
	printf(" Copyright (C) 1989, 1991 Free Software Foundation, Inc.\n");
	printf("                       59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
	printf(" Everyone is permitted to copy and distribute verbatim copies\n");
	printf(" of this license document, but changing it is not allowed.\n");
	printf("\n");
	printf("			    Preamble\n");
	printf("\n");
	printf("  The licenses for most software are designed to take away your\n");
	printf("freedom to share and change it.  By contrast, the GNU General Public\n");
	printf("License is intended to guarantee your freedom to share and change free\n");
	printf("software--to make sure the software is free for all its users.  This\n");
	printf("General Public License applies to most of the Free Software\n");
	printf("Foundation's software and to any other program whose authors commit to\n");
	printf("using it.  (Some other Free Software Foundation software is covered by\n");
	printf("the GNU Library General Public License instead.)  You can apply it to\n");
	printf("your programs, too.\n");
	printf("\n");
	printf("  When we speak of free software, we are referring to freedom, not\n");
	printf("price.  Our General Public Licenses are designed to make sure that you\n");
	printf("have the freedom to distribute copies of free software (and charge for\n");
	printf("this service if you wish), that you receive source code or can get it\n");
	printf("if you want it, that you can change the software or use pieces of it\n");
	printf("in new free programs; and that you know you can do these things.\n");
	printf("\n");
	printf("  To protect your rights, we need to make restrictions that forbid\n");
	printf("anyone to deny you these rights or to ask you to surrender the rights.\n");
	printf("These restrictions translate to certain responsibilities for you if you\n");
	printf("distribute copies of the software, or if you modify it.\n");
	printf("\n");
	printf("  For example, if you distribute copies of such a program, whether\n");
	printf("gratis or for a fee, you must give the recipients all the rights that\n");
	printf("you have.  You must make sure that they, too, receive or can get the\n");
	printf("source code.  And you must show them these terms so they know their\n");
	printf("rights.\n");
	printf("\n");
	printf("  We protect your rights with two steps: (1) copyright the software, and\n");
	printf("(2) offer you this license which gives you legal permission to copy,\n");
	printf("distribute and/or modify the software.\n");
	printf("\n");
	printf("  Also, for each author's protection and ours, we want to make certain\n");
	printf("that everyone understands that there is no warranty for this free\n");
	printf("software.  If the software is modified by someone else and passed on, we\n");
	printf("want its recipients to know that what they have is not the original, so\n");
	printf("that any problems introduced by others will not reflect on the original\n");
	printf("authors' reputations.\n");
	printf("\n");
	printf("  Finally, any free program is threatened constantly by software\n");
	printf("patents.  We wish to avoid the danger that redistributors of a free\n");
	printf("program will individually obtain patent licenses, in effect making the\n");
	printf("program proprietary.  To prevent this, we have made it clear that any\n");
	printf("patent must be licensed for everyone's free use or not licensed at all.\n");
	printf("\n");
	printf("  The precise terms and conditions for copying, distribution and\n");
	printf("modification follow.\n");
	printf("\n");
	printf("		    GNU GENERAL PUBLIC LICENSE\n");
	printf("   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n");
	printf("\n");
	printf("  0. This License applies to any program or other work which contains\n");
	printf("a notice placed by the copyright holder saying it may be distributed\n");
	printf("under the terms of this General Public License.  The \"Program\", below,\n");
	printf("refers to any such program or work, and a \"work based on the Program\"\n");
	printf("means either the Program or any derivative work under copyright law:\n");
	printf("that is to say, a work containing the Program or a portion of it,\n");
	printf("either verbatim or with modifications and/or translated into another\n");
	printf("language.  (Hereinafter, translation is included without limitation in\n");
	printf("the term \"modification\".)  Each licensee is addressed as \"you\".\n");
	printf("\n");
	printf("Activities other than copying, distribution and modification are not\n");
	printf("covered by this License; they are outside its scope.  The act of\n");
	printf("running the Program is not restricted, and the output from the Program\n");
	printf("is covered only if its contents constitute a work based on the\n");
	printf("Program (independent of having been made by running the Program).\n");
	printf("Whether that is true depends on what the Program does.\n");
	printf("\n");
	printf("  1. You may copy and distribute verbatim copies of the Program's\n");
	printf("source code as you receive it, in any medium, provided that you\n");
	printf("conspicuously and appropriately publish on each copy an appropriate\n");
	printf("copyright notice and disclaimer of warranty; keep intact all the\n");
	printf("notices that refer to this License and to the absence of any warranty;\n");
	printf("and give any other recipients of the Program a copy of this License\n");
	printf("along with the Program.\n");
	printf("\n");
	printf("You may charge a fee for the physical act of transferring a copy, and\n");
	printf("you may at your option offer warranty protection in exchange for a fee.\n");
	printf("\n");
	printf("  2. You may modify your copy or copies of the Program or any portion\n");
	printf("of it, thus forming a work based on the Program, and copy and\n");
	printf("distribute such modifications or work under the terms of Section 1\n");
	printf("above, provided that you also meet all of these conditions:\n");
	printf("\n");
	printf("    a) You must cause the modified files to carry prominent notices\n");
	printf("    stating that you changed the files and the date of any change.\n");
	printf("\n");
	printf("    b) You must cause any work that you distribute or publish, that in\n");
	printf("    whole or in part contains or is derived from the Program or any\n");
	printf("    part thereof, to be licensed as a whole at no charge to all third\n");
	printf("    parties under the terms of this License.\n");
	printf("\n");
	printf("    c) If the modified program normally reads commands interactively\n");
	printf("    when run, you must cause it, when started running for such\n");
	printf("    interactive use in the most ordinary way, to print or display an\n");
	printf("    announcement including an appropriate copyright notice and a\n");
	printf("    notice that there is no warranty (or else, saying that you provide\n");
	printf("    a warranty) and that users may redistribute the program under\n");
	printf("    these conditions, and telling the user how to view a copy of this\n");
	printf("    License.  (Exception: if the Program itself is interactive but\n");
	printf("    does not normally print such an announcement, your work based on\n");
	printf("    the Program is not required to print an announcement.)\n");
	printf("\n");
	printf("These requirements apply to the modified work as a whole.  If\n");
	printf("identifiable sections of that work are not derived from the Program,\n");
	printf("and can be reasonably considered independent and separate works in\n");
	printf("themselves, then this License, and its terms, do not apply to those\n");
	printf("sections when you distribute them as separate works.  But when you\n");
	printf("distribute the same sections as part of a whole which is a work based\n");
	printf("on the Program, the distribution of the whole must be on the terms of\n");
	printf("this License, whose permissions for other licensees extend to the\n");
	printf("entire whole, and thus to each and every part regardless of who wrote it.\n");
	printf("\n");
	printf("Thus, it is not the intent of this section to claim rights or contest\n");
	printf("your rights to work written entirely by you; rather, the intent is to\n");
	printf("exercise the right to control the distribution of derivative or\n");
	printf("collective works based on the Program.\n");
	printf("\n");
	printf("In addition, mere aggregation of another work not based on the Program\n");
	printf("with the Program (or with a work based on the Program) on a volume of\n");
	printf("a storage or distribution medium does not bring the other work under\n");
	printf("the scope of this License.\n");
	printf("\n");
	printf("  3. You may copy and distribute the Program (or a work based on it,\n");
	printf("under Section 2) in object code or executable form under the terms of\n");
	printf("Sections 1 and 2 above provided that you also do one of the following:\n");
	printf("\n");
	printf("    a) Accompany it with the complete corresponding machine-readable\n");
	printf("    source code, which must be distributed under the terms of Sections\n");
	printf("    1 and 2 above on a medium customarily used for software interchange; or,\n");
	printf("\n");
	printf("    b) Accompany it with a written offer, valid for at least three\n");
	printf("    years, to give any third party, for a charge no more than your\n");
	printf("    cost of physically performing source distribution, a complete\n");
	printf("    machine-readable copy of the corresponding source code, to be\n");
	printf("    distributed under the terms of Sections 1 and 2 above on a medium\n");
	printf("    customarily used for software interchange; or,\n");
	printf("\n");
	printf("    c) Accompany it with the information you received as to the offer\n");
	printf("    to distribute corresponding source code.  (This alternative is\n");
	printf("    allowed only for noncommercial distribution and only if you\n");
	printf("    received the program in object code or executable form with such\n");
	printf("    an offer, in accord with Subsection b above.)\n");
	printf("\n");
	printf("The source code for a work means the preferred form of the work for\n");
	printf("making modifications to it.  For an executable work, complete source\n");
	printf("code means all the source code for all modules it contains, plus any\n");
	printf("associated interface definition files, plus the scripts used to\n");
	printf("control compilation and installation of the executable.  However, as a\n");
	printf("special exception, the source code distributed need not include\n");
	printf("anything that is normally distributed (in either source or binary\n");
	printf("form) with the major components (compiler, kernel, and so on) of the\n");
	printf("operating system on which the executable runs, unless that component\n");
	printf("itself accompanies the executable.\n");
	printf("\n");
	printf("If distribution of executable or object code is made by offering\n");
	printf("access to copy from a designated place, then offering equivalent\n");
	printf("access to copy the source code from the same place counts as\n");
	printf("distribution of the source code, even though third parties are not\n");
	printf("compelled to copy the source along with the object code.\n");
	printf("\n");
	printf("  4. You may not copy, modify, sublicense, or distribute the Program\n");
	printf("except as expressly provided under this License.  Any attempt\n");
	printf("otherwise to copy, modify, sublicense or distribute the Program is\n");
	printf("void, and will automatically terminate your rights under this License.\n");
	printf("However, parties who have received copies, or rights, from you under\n");
	printf("this License will not have their licenses terminated so long as such\n");
	printf("parties remain in full compliance.\n");
	printf("\n");
	printf("  5. You are not required to accept this License, since you have not\n");
	printf("signed it.  However, nothing else grants you permission to modify or\n");
	printf("distribute the Program or its derivative works.  These actions are\n");
	printf("prohibited by law if you do not accept this License.  Therefore, by\n");
	printf("modifying or distributing the Program (or any work based on the\n");
	printf("Program), you indicate your acceptance of this License to do so, and\n");
	printf("all its terms and conditions for copying, distributing or modifying\n");
	printf("the Program or works based on it.\n");
	printf("\n");
	printf("  6. Each time you redistribute the Program (or any work based on the\n");
	printf("Program), the recipient automatically receives a license from the\n");
	printf("original licensor to copy, distribute or modify the Program subject to\n");
	printf("these terms and conditions.  You may not impose any further\n");
	printf("restrictions on the recipients' exercise of the rights granted herein.\n");
	printf("You are not responsible for enforcing compliance by third parties to\n");
	printf("this License.\n");
	printf("\n");
	printf("  7. If, as a consequence of a court judgment or allegation of patent\n");
	printf("infringement or for any other reason (not limited to patent issues),\n");
	printf("conditions are imposed on you (whether by court order, agreement or\n");
	printf("otherwise) that contradict the conditions of this License, they do not\n");
	printf("excuse you from the conditions of this License.  If you cannot\n");
	printf("distribute so as to satisfy simultaneously your obligations under this\n");
	printf("License and any other pertinent obligations, then as a consequence you\n");
	printf("may not distribute the Program at all.  For example, if a patent\n");
	printf("license would not permit royalty-free redistribution of the Program by\n");
	printf("all those who receive copies directly or indirectly through you, then\n");
	printf("the only way you could satisfy both it and this License would be to\n");
	printf("refrain entirely from distribution of the Program.\n");
	printf("\n");
	printf("If any portion of this section is held invalid or unenforceable under\n");
	printf("any particular circumstance, the balance of the section is intended to\n");
	printf("apply and the section as a whole is intended to apply in other\n");
	printf("circumstances.\n");
	printf("\n");
	printf("It is not the purpose of this section to induce you to infringe any\n");
	printf("patents or other property right claims or to contest validity of any\n");
	printf("such claims; this section has the sole purpose of protecting the\n");
	printf("integrity of the free software distribution system, which is\n");
	printf("implemented by public license practices.  Many people have made\n");
	printf("generous contributions to the wide range of software distributed\n");
	printf("through that system in reliance on consistent application of that\n");
	printf("system; it is up to the author/donor to decide if he or she is willing\n");
	printf("to distribute software through any other system and a licensee cannot\n");
	printf("impose that choice.\n");
	printf("\n");
	printf("This section is intended to make thoroughly clear what is believed to\n");
	printf("be a consequence of the rest of this License.\n");
	printf("\n");
	printf("  8. If the distribution and/or use of the Program is restricted in\n");
	printf("certain countries either by patents or by copyrighted interfaces, the\n");
	printf("original copyright holder who places the Program under this License\n");
	printf("may add an explicit geographical distribution limitation excluding\n");
	printf("those countries, so that distribution is permitted only in or among\n");
	printf("countries not thus excluded.  In such case, this License incorporates\n");
	printf("the limitation as if written in the body of this License.\n");
	printf("\n");
	printf("  9. The Free Software Foundation may publish revised and/or new versions\n");
	printf("of the General Public License from time to time.  Such new versions will\n");
	printf("be similar in spirit to the present version, but may differ in detail to\n");
	printf("address new problems or concerns.\n");
	printf("\n");
	printf("Each version is given a distinguishing version number.  If the Program\n");
	printf("specifies a version number of this License which applies to it and \"any\n");
	printf("later version\", you have the option of following the terms and conditions\n");
	printf("either of that version or of any later version published by the Free\n");
	printf("Software Foundation.  If the Program does not specify a version number of\n");
	printf("this License, you may choose any version ever published by the Free Software\n");
	printf("Foundation.\n");
	printf("\n");
	printf("  10. If you wish to incorporate parts of the Program into other free\n");
	printf("programs whose distribution conditions are different, write to the author\n");
	printf("to ask for permission.  For software which is copyrighted by the Free\n");
	printf("Software Foundation, write to the Free Software Foundation; we sometimes\n");
	printf("make exceptions for this.  Our decision will be guided by the two goals\n");
	printf("of preserving the free status of all derivatives of our free software and\n");
	printf("of promoting the sharing and reuse of software generally.\n");
	printf("\n");
	printf("			    NO WARRANTY\n");
	printf("\n");
	printf("  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY\n");
	printf("FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN\n");
	printf("OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES\n");
	printf("PROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED\n");
	printf("OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF\n");
	printf("MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS\n");
	printf("TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE\n");
	printf("PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,\n");
	printf("REPAIR OR CORRECTION.\n");
	printf("\n");
	printf("  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING\n");
	printf("WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR\n");
	printf("REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,\n");
	printf("INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING\n");
	printf("OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED\n");
	printf("TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY\n");
	printf("YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER\n");
	printf("PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE\n");
	printf("POSSIBILITY OF SUCH DAMAGES.\n");
	printf("\n");
	printf("		     END OF TERMS AND CONDITIONS\n");
	printf("\n");
	printf("	    How to Apply These Terms to Your New Programs\n");
	printf("\n");
	printf("  If you develop a new program, and you want it to be of the greatest\n");
	printf("possible use to the public, the best way to achieve this is to make it\n");
	printf("free software which everyone can redistribute and change under these terms.\n");
	printf("\n");
	printf("  To do so, attach the following notices to the program.  It is safest\n");
	printf("to attach them to the start of each source file to most effectively\n");
	printf("convey the exclusion of warranty; and each file should have at least\n");
	printf("the \"copyright\" line and a pointer to where the full notice is found.\n");
	printf("\n");
	printf("    <one line to give the program's name and a brief idea of what it does.>\n");
	printf("    Copyright (C) <year>  <name of author>\n");
	printf("\n");
	printf("    This program is free software; you can redistribute it and/or modify\n");
	printf("    it under the terms of the GNU General Public License as published by\n");
	printf("    the Free Software Foundation; either version 2 of the License, or\n");
	printf("    (at your option) any later version.\n");
	printf("\n");
	printf("    This program is distributed in the hope that it will be useful,\n");
	printf("    but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
	printf("    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
	printf("    GNU General Public License for more details.\n");
	printf("\n");
	printf("    You should have received a copy of the GNU General Public License\n");
	printf("    along with this program; if not, write to the Free Software\n");
	printf("    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
	printf("\n");
	printf("\n");
	printf("Also add information on how to contact you by electronic and paper mail.\n");
	printf("\n");
	printf("If the program is interactive, make it output a short notice like this\n");
	printf("when it starts in an interactive mode:\n");
	printf("\n");
	printf("    Gnomovision version 69, Copyright (C) year name of author\n");
	printf("    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.\n");
	printf("    This is free software, and you are welcome to redistribute it\n");
	printf("    under certain conditions; type `show c' for details.\n");
	printf("\n");
	printf("The hypothetical commands `show w' and `show c' should show the appropriate\n");
	printf("parts of the General Public License.  Of course, the commands you use may\n");
	printf("be called something other than `show w' and `show c'; they could even be\n");
	printf("mouse-clicks or menu items--whatever suits your program.\n");
	printf("\n");
	printf("You should also get your employer (if you work as a programmer) or your\n");
	printf("school, if any, to sign a \"copyright disclaimer\" for the program, if\n");
	printf("necessary.  Here is a sample; alter the names:\n");
	printf("\n");
	printf("  Yoyodyne, Inc., hereby disclaims all copyright interest in the program\n");
	printf("  `Gnomovision' (which makes passes at compilers) written by James Hacker.\n");
	printf("\n");
	printf("  <signature of Ty Coon>, 1 April 1989\n");
	printf("  Ty Coon, President of Vice\n");
	printf("\n");
	printf("This General Public License does not permit incorporating your program into\n");
	printf("proprietary programs.  If your program is a subroutine library, you may\n");
	printf("consider it more useful to permit linking proprietary applications with the\n");
	printf("library.  If this is what you want to do, use the GNU Library General\n");
	printf("Public License instead of this License.\n");
	printf("\n");

}
int main(int argc,char** argv)
{
	FILE *f;
	int i=0;
	int j=0;
	int k=0;
	float xoffs=0;
	float yoffs=0;
	float nxoffs=0;
	float nyoffs=0;
	unsigned char line[1024];
	unsigned char tmp1[1024];
	unsigned char tmp2[1024];
	unsigned char tmp3[1024];
	unsigned char tmp4[1024];
	unsigned char tmp5[1024];
	unsigned char tmp6[1024];
	unsigned char tmp7[1024];
	_part parts[1024];
	int partnum=0;
	int draw=0;
	int p=0;
	int linenum=0;
	float t1,t2;
	int a=1;
	int help=0;

	fprintf(stderr,"*** circdraw ");fprintf(stderr,RELEASE);fprintf(stderr,"\n");
	fprintf(stderr,"*** (C)opyleft 2007 by Dettus\n");
	fprintf(stderr,"*** dettus@dettus.net (write circdraw into the subject)\n");
	fprintf(stderr,"*******************************************************\n\n\n");
	fprintf(stderr,"This program is free software; you can redistribute it and/or modify\n");
	fprintf(stderr,"it under the terms of the GNU General Public License as published by\n");
	fprintf(stderr,"the Free Software Foundation; either version 2 of the License, or\n");
	fprintf(stderr,"(at your option) any later version.\n");
	fprintf(stderr,"\n");
	fprintf(stderr,"This program is distributed in the hope that it will be useful,\n");
	fprintf(stderr,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
	fprintf(stderr,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
	fprintf(stderr,"GNU General Public License for more details.\n");
	fprintf(stderr,"\n");
	fprintf(stderr,"You should have received a copy of the GNU General Public License\n");
	fprintf(stderr,"along with this program; if not, write to the Free Software\n");
	fprintf(stderr,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
	if (argc<2) help=1;
	if (!help) if (strncmp(argv[1],"--help",6)==0) help=1;

	if (help)
	{
		fprintf(stderr,"%s [--help | -gpl | -d | -p | -i] filename.circ\n",argv[0]);
		fprintf(stderr,"\n\nwhere\n-gpl gives you information about the license\n-d   prints debugging information into the the output\n-p   helps you debugging the parts\n-i   helps you debugging the interfaces\n");
		exit(0);
	}
	if (strncmp(argv[1],"-gpl",4)==0)
	{
		gpl();
		exit(1);
	}
	for (a=1;a<(argc-1);a++)
	{
		if (strncmp(argv[1],"-p",2)==0) 
		{
			parthelp=1;
		}
		if (strncmp(argv[1],"-i",2)==0) 
		{
			porthelp=1;
		}
		if (strncmp(argv[a],"-d",2)==0)
		{
			debughelp=1;
		}
	}
	if (debughelp) fprintf(stderr,"help> printing debug information\n");	
	if (parthelp) fprintf(stderr,"help> printing part information\n");	
	if (porthelp) fprintf(stderr,"help> printing interface information\n");	
	fprintf(stderr,"init> opening [%s]\n",argv[a]);
	f=fopen(argv[a],"rb");
	while (!feof(f))
	{
		freadline(line,sizeof(line),f);
		if (draw && !feof(f))
		{
			fprintf(stderr,"read> line %i: %s",++linenum,line);
			if (debughelp) 
			{
				printf("  %%%% %s",line);
			}
			if (strncmp(line,"start ",6)==0)
			{
				p=readtoken(tmp1,line,' ',0);
				p=readtoken(tmp1,line,' ',p);
				xoffs=getfloat(tmp1);
				p=readtoken(tmp1,line,' ',p);
				yoffs=getfloat(tmp1);
			
				fprintf(stderr,"circ> cursor set @%7.3f,%7.3f\n",xoffs,yoffs);
			
			}
			if (strncmp(line,"part ",5)==0)
			{
				p=readtoken(tmp1,line,' ',0);// "part"
				p=readtoken(tmp2,line,' ',p);// partname 
				p=readtoken(tmp3,line,' ',p);// filename
				p=readtoken(tmp4,line,' ',p);// portname
				fprintf(stderr,"circ> part #%i is [%s] @%7.3f, %7.3f\n",partnum,tmp2,xoffs,yoffs);

				parts[partnum++]=putpart(tmp3,tmp2,tmp4,xoffs,yoffs,0);
			}
			if (strncmp(line,"from ",5)==0)
			{
				p=readtoken(tmp1,line,' ',0);// "from"
				p=readtoken(tmp2,line,' ',p);// partname
				p=readtoken(tmp3,line,' ',p);// portname
				p=readtoken(tmp4,line,' ',p);// "draw"/"move"
				p=readtoken(tmp5,line,' ',p);// x
				p=readtoken(tmp6,line,' ',p);// y
				fprintf(stderr,"from> trying to find part [%s]\n",tmp2);
				j=-1;
				for (i=0;(i<partnum && j==-1);i++)
				{
					if (strncmp(tmp2,parts[i].name,128)==0) j=i;
				}
				if (j!=-1)
				{
					fprintf(stderr,"from> part #%i part. trying to find port [%s]\n",j,tmp3);
					k=-1;
					for (i=0;(i<parts[j].portnum && k==-1);i++)
					{
						if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
					}
					if (k!=-1)
					{
						fprintf(stderr,"from> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
						xoffs=parts[j].ports[k].xpos;
						yoffs=parts[j].ports[k].ypos;
						fprintf(stderr,"from> cursor set @%7.3f,%7.3f\n",xoffs,yoffs);

						nxoffs=xoffs+getfloat(tmp5);
						nyoffs=yoffs+getfloat(tmp6);
						if (strncmp(tmp4,"move",4)==0) {xoffs=nxoffs;yoffs=nyoffs;}
						if (strncmp(tmp4,"draw",4)==0) {
							printf("\\plot %7.3f %7.3f  %7.3f %7.3f /\n",xoffs,yoffs,nxoffs,nyoffs);
							xoffs=nxoffs;yoffs=nyoffs;
						}
						fprintf(stderr,"from> cursor set @%7.3f,%7.3f\n",xoffs,yoffs);
					}
				} else {fprintf(stderr,"from> not found\n");}


			}
			if (strncmp(line,"goto ",5)==0)
			{
				p=readtoken(tmp1,line,' ',0);// "from"
				p=readtoken(tmp2,line,' ',p);// partname
				p=readtoken(tmp3,line,' ',p);// portname
				fprintf(stderr,"goto> trying to find part [%s]\n",tmp2);
				j=-1;
				for (i=0;(i<partnum && j==-1);i++)
				{
					if (strncmp(tmp2,parts[i].name,128)==0) j=i;
				}
				if (j!=-1)
				{
					fprintf(stderr,"goto> part #%i part. trying to find port [%s]\n",j,tmp3);
					k=-1;
					for (i=0;(i<parts[j].portnum && k==-1);i++)
					{
						if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
					}
					if (k!=-1)
					{
						fprintf(stderr,"goto> part #%i port #%i\n",j,k);
						xoffs=parts[j].ports[k].xpos;
						yoffs=parts[j].ports[k].ypos;
						fprintf(stderr,"goto> cursor set @%7.3f,%7.3f\n",xoffs,yoffs);

					} else if (strncmp(tmp3,"-",1)==0) 
					{
						xoffs=parts[j].xpos+parts[j].parts.sizex/2;
						yoffs=parts[j].ypos+parts[j].parts.sizey/2;
						
					}
				} else {fprintf(stderr,"goto> not found\n");}
			}
			if (strncmp(line,"centerv",7)==0)
			{
				p=readtoken(tmp1,line,' ',0);// "centerv"
				p=readtoken(tmp2,line,' ',p);// part1
				p=readtoken(tmp3,line,' ',p);// part1.port
				p=readtoken(tmp4,line,' ',p);// part2
				p=readtoken(tmp5,line,' ',p);// part2.port
				p=readtoken(tmp6,line,' ',p);// "draw"/"move"
				fprintf(stderr,"centerv> trying to find part [%s]\n",tmp2);
				j=-1;
				for (i=0;(i<partnum && j==-1);i++)
				{
					if (strncmp(tmp2,parts[i].name,128)==0) j=i;
				}
				if (j!=-1)
				{
					fprintf(stderr,"centerv> part #%i part. trying to find port [%s]\n",j,tmp3);
					k=-1;
					for (i=0;(i<parts[j].portnum && k==-1);i++)
					{
						if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
					}
					if (k!=-1)
					{
						fprintf(stderr,"centerv> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
						t1=parts[j].ports[k].ypos;

					}
				} else {fprintf(stderr,"centerv> not found\n");}
				fprintf(stderr,"centerv> trying to find part [%s]\n",tmp4);
				j=-1;
				for (i=0;(i<partnum && j==-1);i++)
				{
					if (strncmp(tmp4,parts[i].name,128)==0) j=i;
				}
				if (j!=-1)
				{
					fprintf(stderr,"centerv> part #%i part. trying to find port [%s]\n",j,tmp5);
					k=-1;
					for (i=0;(i<parts[j].portnum && k==-1);i++)
					{
						if (strncmp(tmp5,parts[j].ports[i].name,128)==0) k=i;
					}
					if (k!=-1)
					{
						fprintf(stderr,"centerv> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
						t2=parts[j].ports[k].ypos;

					}
					nyoffs=(t2+t1)/2;
					if (strncmp(tmp6,"draw",4)==0) printf("\\plot %7.3f %7.3f %7.3f %7.3f / %%%% centerv\n",xoffs,yoffs,xoffs,nyoffs);
					yoffs=nyoffs;
				} else {fprintf(stderr,"centerv> not found\n");}
				fprintf(stderr,"centerv> cursor set @%7.3f,%7.3f\n",xoffs,yoffs);
			}

			if (strncmp(line,"centerh",7)==0)
			{
				p=readtoken(tmp1,line,' ',0);// "centerh"
				p=readtoken(tmp2,line,' ',p);// part1
				p=readtoken(tmp3,line,' ',p);// part1.port
				p=readtoken(tmp4,line,' ',p);// part2
				p=readtoken(tmp5,line,' ',p);// part2.port
				p=readtoken(tmp6,line,' ',p);// "draw"/"move"
				fprintf(stderr,"centerh> trying to find part [%s]\n",tmp2);
				j=-1;
				for (i=0;(i<partnum && j==-1);i++)
				{
					if (strncmp(tmp2,parts[i].name,128)==0) j=i;
				}
				if (j!=-1)
				{
					fprintf(stderr,"centerh> part #%i part. trying to find port [%s]\n",j,tmp3);
					k=-1;
					for (i=0;(i<parts[j].portnum && k==-1);i++)
					{
						if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
					}
					if (k!=-1)
					{
						fprintf(stderr,"centerh> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
						t1=parts[j].ports[k].xpos;

					}
				} else {fprintf(stderr,"centerh> not found\n");}
				fprintf(stderr,"centerh> trying to find part [%s]\n",tmp4);
				j=-1;
				for (i=0;(i<partnum && j==-1);i++)
				{
					if (strncmp(tmp4,parts[i].name,128)==0) j=i;
				}
				if (j!=-1)
				{
					fprintf(stderr,"centerh> part #%i part. trying to find port [%s]\n",j,tmp5);
					k=-1;
					for (i=0;(i<parts[j].portnum && k==-1);i++)
					{
						if (strncmp(tmp5,parts[j].ports[i].name,128)==0) k=i;
					}
					if (k!=-1)
					{
						fprintf(stderr,"centerh> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
						t2=parts[j].ports[k].xpos;

					}
					nxoffs=(t2+t1)/2;
					if (strncmp(tmp6,"draw",4)==0) printf("\\plot %7.3f %7.3f %7.3f %7.3f / %%%% centerh\n",xoffs,yoffs,nxoffs,yoffs);
					xoffs=nxoffs;
				} else {fprintf(stderr,"centerh> not found\n");}
				fprintf(stderr,"centerh> cursor set @%7.3f,%7.3f\n",xoffs,yoffs);
			}
			if (strncmp(line,"drawv",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "drawv"
                                p=readtoken(tmp2,line,' ',p);// part1
                                p=readtoken(tmp3,line,' ',p);// part1.port
				
                                fprintf(stderr,"drawv> trying to find part [%s]\n",tmp2);
                                j=-1;
                                for (i=0;(i<partnum && j==-1);i++)
                                {
                                        if (strncmp(tmp2,parts[i].name,128)==0) j=i;
                                }
                                if (j!=-1)
                                {
                                        fprintf(stderr,"drawv> part #%i part. trying to find port [%s]\n",j,tmp3);
                                        k=-1;
                                        for (i=0;(i<parts[j].portnum && k==-1);i++)
                                        {
                                                if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
                                        }
                                        if (k!=-1)
                                        {
                                                fprintf(stderr,"drawv> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
                                                nyoffs=parts[j].ports[k].ypos;

                                        }
					printf("\\plot %7.3f %7.3f %7.3f %7.3f / %%%% drawv\n",xoffs,yoffs,xoffs,nyoffs);	
					yoffs=nyoffs;
                                } else {fprintf(stderr,"drawv> not found\n");}
			}

			if (strncmp(line,"drawh",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "drawh"
                                p=readtoken(tmp2,line,' ',p);// part1
                                p=readtoken(tmp3,line,' ',p);// part1.port
				
                                fprintf(stderr,"drawh> trying to find part [%s]\n",tmp2);
                                j=-1;
                                for (i=0;(i<partnum && j==-1);i++)
                                {
                                        if (strncmp(tmp2,parts[i].name,128)==0) j=i;
                                }
                                if (j!=-1)
                                {
                                        fprintf(stderr,"drawh> part #%i part. trying to find port [%s]\n",j,tmp3);
                                        k=-1;
                                        for (i=0;(i<parts[j].portnum && k==-1);i++)
                                        {
                                                if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
                                        }
                                        if (k!=-1)
                                        {
                                                fprintf(stderr,"drawh> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
                                                nxoffs=parts[j].ports[k].xpos;

                                        }
					printf("\\plot %7.3f %7.3f %7.3f %7.3f / %%%% drawh\n",xoffs,yoffs,nxoffs,yoffs);	
					xoffs=nxoffs;
                                } else {fprintf(stderr,"drawh> not found\n");}
			}

			if (strncmp(line,"movev",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "movev"
                                p=readtoken(tmp2,line,' ',p);// part1
                                p=readtoken(tmp3,line,' ',p);// part1.port
				
                                fprintf(stderr,"movev> trying to find part [%s]\n",tmp2);
                                j=-1;
                                for (i=0;(i<partnum && j==-1);i++)
                                {
                                        if (strncmp(tmp2,parts[i].name,128)==0) j=i;
                                }
                                if (j!=-1)
                                {
                                        fprintf(stderr,"movev> part #%i part. trying to find port [%s]\n",j,tmp3);
                                        k=-1;
                                        for (i=0;(i<parts[j].portnum && k==-1);i++)
                                        {
                                                if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
                                        }
                                        if (k!=-1)
                                        {
                                                fprintf(stderr,"movev> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
                                                nyoffs=parts[j].ports[k].ypos;

                                        }
					yoffs=nyoffs;
                                } else {fprintf(stderr,"movev> not found\n");}
			}

			if (strncmp(line,"moveh",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "moveh"
                                p=readtoken(tmp2,line,' ',p);// part1
                                p=readtoken(tmp3,line,' ',p);// part1.port
				
                                fprintf(stderr,"moveh> trying to find part [%s]\n",tmp2);
                                j=-1;
                                for (i=0;(i<partnum && j==-1);i++)
                                {
                                        if (strncmp(tmp2,parts[i].name,128)==0) j=i;
                                }
                                if (j!=-1)
                                {
                                        fprintf(stderr,"moveh> part #%i part. trying to find port [%s]\n",j,tmp3);
                                        k=-1;
                                        for (i=0;(i<parts[j].portnum && k==-1);i++)
                                        {
                                                if (strncmp(tmp3,parts[j].ports[i].name,128)==0) k=i;
                                        }
                                        if (k!=-1)
                                        {
                                                fprintf(stderr,"moveh> part #%i port #%i @%7.3f,%7.3f\n",j,k,parts[j].ports[k].xpos,parts[j].ports[k].ypos);
                                                nxoffs=parts[j].ports[k].xpos;

                                        }
					xoffs=nxoffs;
                                } else {fprintf(stderr,"moveh> not found\n");}
			}

			if (strncmp(line,"move ",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "move"
                                p=readtoken(tmp2,line,' ',p);// part1
                                p=readtoken(tmp3,line,' ',p);// part1.port

				nxoffs=getfloat(tmp2);				
				nyoffs=getfloat(tmp3);				

//				printf("\\plot %7.3f %7.3f %7.3f %7.3f / %%%% drawh\n",xoffs,yoffs,nxoffs,nyoffs);	
				xoffs=xoffs+nxoffs;
				yoffs=yoffs+nyoffs;
			}

			if (strncmp(line,"draw ",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "draw"
                                p=readtoken(tmp2,line,' ',p);// part1
                                p=readtoken(tmp3,line,' ',p);// part1.port

				nxoffs=getfloat(tmp2);				
				nyoffs=getfloat(tmp3);				

				printf("\\plot %7.3f %7.3f %7.3f %7.3f / %%%% draw\n",xoffs,yoffs,xoffs+nxoffs,yoffs+nyoffs);	
				xoffs=xoffs+nxoffs;
				yoffs=yoffs+nyoffs;
			}

			if (strncmp(line,"mark ",5)==0)
			{
                                p=readtoken(tmp1,line,' ',0);// "mark"
                                p=readtoken(tmp2,line,' ',p);// name

				printf(" %%%% mark %s at %7.3f %7.3f\n",tmp2,xoffs,yoffs);
				strncpy(parts[partnum].name,tmp2,128);
				parts[partnum].xpos=xoffs;
				parts[partnum].ypos=yoffs;
				parts[partnum].rotate=0;
				parts[partnum].portnum=0;
				parts[partnum].parts.sizex=0;
				parts[partnum].parts.sizey=0;
				
				partnum++;
			}
			if (strncmp(line,"text ",5)==0)
			{
				for (i=5;i<strlen(line);i++) if (line[i]<32) line[i]=0;
				printf("\\put {%s} at %7.3f %7.3f \n",line+5,xoffs,yoffs);
			}

		}
		if (strncmp(line,"[draw]",6)==0) draw=1;

	}
	fprintf(stderr,"\n");

	if (debughelp) fprintf(stderr,"help> debug information printed\n");	
	if (parthelp) fprintf(stderr,"help> part information printed\n");	
	if (porthelp) fprintf(stderr,"help> interface information printed\n");	

}

